﻿using System.Collections.Generic;
using Godot;
using TBL.GodotSharp.Content.FileSystem;
using Zio;

namespace TBL.GodotSharp.Content.Package
{
    /// <summary>
    /// 内部内容包
    /// </summary>
    internal class InternalPackage : PackageNode
    {
        public override IFileSystem SelfFileSystem { get; }

        public override Info SelfInfo { get; }
    
        public override IEnumerable<DependencyInfo> Dependencies { get; }

        public InternalPackage(Info info) : this(info, string.Empty)
        {
        }
        
        public InternalPackage(Info info, string root)
        {
            SelfFileSystem = new GodotFileSystem($"res://{root}");
            SelfInfo = root.Empty() 
                ? info
                : new Info($"{info.Name}.{root}", info.AuthorInfo, info.VersionInfo)
                ;
            Dependencies = null;
        }
    }
}
